import { Encoding, EncodingSpecifier, PrototypeEncoding, PrototypeSpecifier, SymbolEncoding } from "../interface";
export declare class EncodingStore {
    private _nameToProtoEncodings;
    private _symbolToEncoding;
    private _protoToEncoding;
    private _keyToEncoding;
    private _indexToEncoding;
    private _cacheProtoToEncoding;
    all(): Encoding[];
    private _getBuiltInEncoding;
    private _isBuiltIn;
    private _registerProtos;
    _addEncoding(encoding: Encoding): void;
    _maybeRegisterFixedIndexEncoding(encoding: Encoding): void;
    makeEncodingFromCtor(ctor: Function): PrototypeEncoding<object>;
    makeEncodingFromProtoSpec(specifier: PrototypeSpecifier): PrototypeEncoding;
    makeEncoding(encoding: EncodingSpecifier): Encoding;
    add(...encodings: (Encoding | EncodingSpecifier)[]): void;
    private _addProtoEncoding;
    getProtoEncodings(): Generator<PrototypeEncoding>;
    getSymbolEncodings(): Iterable<SymbolEncoding>;
    private _addSymbolEncoding;
    mayGetBySymbol(s: symbol): SymbolEncoding | undefined;
    mustGetByIndex(ix: number): Encoding;
    mustGetByKey(key: string): Encoding;
    private _makeWorkingProtoCache;
    mustGetByProto(obj: object): PrototypeEncoding & {
        name: string;
    };
}
//# sourceMappingURL=store.d.ts.map