"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setEncoding = exports.mapEncoding = void 0;
const interface_1 = require("../interface");
const utils_1 = require("../utils");
const fixed_indexes_1 = require("./fixed-indexes");
const utils_2 = require("./utils");
exports.mapEncoding = (0, utils_2.defineProtoEncoding)(class MapEncoding extends interface_1.PrototypeEncoding {
    constructor() {
        super(...arguments);
        this.fixedIndex = fixed_indexes_1.FixedIndexes.Map;
        this.name = (0, utils_1.getBuiltInEncodingName)("Map");
        this.version = 0;
        this.encodes = Map.prototype;
        this.decoder = new (class MapDecoder {
            create(encodedValue, ctx) {
                return new Map();
            }
            init(target, encoded, ctx) {
                for (const [key, value] of encoded) {
                    target.set(ctx.decode(key), ctx.decode(value));
                }
            }
        })();
    }
    encode(input, ctx) {
        const array = [];
        for (const key of input.keys()) {
            const value = input.get(key);
            array.push([ctx.encode(key), ctx.encode(value)]);
        }
        return array;
    }
});
exports.setEncoding = (0, utils_2.defineProtoEncoding)(class SetEncoding extends interface_1.PrototypeEncoding {
    constructor() {
        super(...arguments);
        this.fixedIndex = fixed_indexes_1.FixedIndexes.Set;
        this.name = (0, utils_1.getBuiltInEncodingName)("Set");
        this.version = 0;
        this.encodes = Set.prototype;
        this.decoder = new (class SetDecoder {
            create() {
                return new Set();
            }
            init(target, encoded, ctx) {
                for (const item of encoded) {
                    target.add(ctx.decode(item));
                }
            }
        })();
    }
    encode(input, ctx) {
        const outArray = [];
        for (const item of input) {
            outArray.push(ctx.encode(item));
        }
        return outArray;
    }
});
//# sourceMappingURL=collections.js.map