"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorEncodings = exports.createErrorEncoding = void 0;
const interface_1 = require("../interface");
const utils_1 = require("../utils");
const objects_1 = require("./objects");
const fixed_indexes_1 = require("./fixed-indexes");
const utils_2 = require("./utils");
const errorProperties = ["stack", "name", "message"];
function createErrorEncoding(index, errorCtor) {
    return (0, utils_2.defineProtoEncoding)(class ErrorSubtypeEncoding extends interface_1.PrototypeEncoding {
        constructor() {
            super(...arguments);
            this.fixedIndex = index;
            this.encodes = errorCtor.prototype;
            this.version = 0;
            this.name = (0, utils_1.getBuiltInEncodingName)(errorCtor.name);
            this.decoder = {
                create(encodedValue, ctx) {
                    return new errorCtor();
                },
                init(target, encoded, ctx) {
                    (0, objects_1.decodeObject)(target, encoded, ctx);
                }
            };
        }
        encode(input, ctx) {
            const encodedAsObject = (0, objects_1.encodeObject)(input, ctx, false, errorProperties);
            ctx._isImplicit = false;
            return encodedAsObject;
        }
    });
}
exports.createErrorEncoding = createErrorEncoding;
exports.errorEncodings = [
    createErrorEncoding(fixed_indexes_1.FixedIndexes.EvalError, EvalError),
    createErrorEncoding(fixed_indexes_1.FixedIndexes.RangeError, RangeError),
    createErrorEncoding(fixed_indexes_1.FixedIndexes.ReferenceError, ReferenceError),
    createErrorEncoding(fixed_indexes_1.FixedIndexes.TypeError, TypeError),
    createErrorEncoding(fixed_indexes_1.FixedIndexes.URIError, URIError),
    createErrorEncoding(fixed_indexes_1.FixedIndexes.SyntaxError, SyntaxError),
    createErrorEncoding(fixed_indexes_1.FixedIndexes.Error, Error)
];
//# sourceMappingURL=errors.js.map