"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FixedIndexes = void 0;
// Fixed indexes for built-in encodings. This makes payloads smaller
// and access a tiny bit faster for them.
var FixedIndexes;
(function (FixedIndexes) {
    /*** UNSUPPORTED BLOCK */
    // OBJECT BLOCK
    FixedIndexes[FixedIndexes["Object"] = 1] = "Object";
    FixedIndexes[FixedIndexes["Array"] = 2] = "Array";
    FixedIndexes[FixedIndexes["NullProto"] = 3] = "NullProto";
    FixedIndexes[FixedIndexes["Map"] = 4] = "Map";
    FixedIndexes[FixedIndexes["Set"] = 5] = "Set";
    // SCALAR BLOCK
    FixedIndexes[FixedIndexes["RegExp"] = 10] = "RegExp";
    FixedIndexes[FixedIndexes["Date"] = 11] = "Date";
    FixedIndexes[FixedIndexes["FundBool"] = 12] = "FundBool";
    FixedIndexes[FixedIndexes["FundString"] = 13] = "FundString";
    FixedIndexes[FixedIndexes["FundNumber"] = 14] = "FundNumber";
    // BINARY BLOCK
    FixedIndexes[FixedIndexes["ArrayBuffer"] = 20] = "ArrayBuffer";
    FixedIndexes[FixedIndexes["SharedArrayBuffer"] = 21] = "SharedArrayBuffer";
    FixedIndexes[FixedIndexes["Uint8Array"] = 22] = "Uint8Array";
    FixedIndexes[FixedIndexes["Uint8ClampedArray"] = 23] = "Uint8ClampedArray";
    FixedIndexes[FixedIndexes["Uint16Array"] = 24] = "Uint16Array";
    FixedIndexes[FixedIndexes["Uint32Array"] = 25] = "Uint32Array";
    FixedIndexes[FixedIndexes["Int8Array"] = 26] = "Int8Array";
    FixedIndexes[FixedIndexes["Int16Array"] = 27] = "Int16Array";
    FixedIndexes[FixedIndexes["Int32Array"] = 28] = "Int32Array";
    FixedIndexes[FixedIndexes["Float32Array"] = 29] = "Float32Array";
    FixedIndexes[FixedIndexes["Float64Array"] = 30] = "Float64Array";
    FixedIndexes[FixedIndexes["DataView"] = 31] = "DataView";
    FixedIndexes[FixedIndexes["BigUint64Array"] = 32] = "BigUint64Array";
    FixedIndexes[FixedIndexes["BigInt64Array"] = 33] = "BigInt64Array";
    // ERROR BLOCK
    FixedIndexes[FixedIndexes["EvalError"] = 50] = "EvalError";
    FixedIndexes[FixedIndexes["RangeError"] = 51] = "RangeError";
    FixedIndexes[FixedIndexes["ReferenceError"] = 52] = "ReferenceError";
    FixedIndexes[FixedIndexes["TypeError"] = 53] = "TypeError";
    FixedIndexes[FixedIndexes["URIError"] = 54] = "URIError";
    FixedIndexes[FixedIndexes["SyntaxError"] = 55] = "SyntaxError";
    FixedIndexes[FixedIndexes["Error"] = 56] = "Error";
    // UNSUPPORTED BLOCK
    FixedIndexes[FixedIndexes["Function"] = 70] = "Function";
    FixedIndexes[FixedIndexes["GeneratorFunction"] = 71] = "GeneratorFunction";
    FixedIndexes[FixedIndexes["Generator"] = 72] = "Generator";
    FixedIndexes[FixedIndexes["Promise"] = 73] = "Promise";
    FixedIndexes[FixedIndexes["WeakSet"] = 74] = "WeakSet";
    FixedIndexes[FixedIndexes["WeakMap"] = 75] = "WeakMap";
    FixedIndexes[FixedIndexes["AsyncGenerator"] = 76] = "AsyncGenerator";
    FixedIndexes[FixedIndexes["AsyncGeneratorFunction"] = 77] = "AsyncGeneratorFunction";
    FixedIndexes[FixedIndexes["FinalizationRegistry"] = 78] = "FinalizationRegistry";
    FixedIndexes[FixedIndexes["AsyncFunction"] = 79] = "AsyncFunction";
    FixedIndexes[FixedIndexes["WeakRef"] = 80] = "WeakRef";
    FixedIndexes[FixedIndexes["MapIterator"] = 81] = "MapIterator";
    FixedIndexes[FixedIndexes["SetIterator"] = 82] = "SetIterator";
    FixedIndexes[FixedIndexes["ArrayIterator"] = 83] = "ArrayIterator";
    // UNRECOGNIZED SYMBOL
    FixedIndexes[FixedIndexes["UnknownSymbol"] = 98] = "UnknownSymbol";
    FixedIndexes[FixedIndexes["End"] = 100] = "End";
    // Block end marker 100
    // Custom encodings start at index 100.
})(FixedIndexes = exports.FixedIndexes || (exports.FixedIndexes = {}));
//# sourceMappingURL=fixed-indexes.js.map