"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultStore = exports.objectEncoding = exports.nullPlaceholder = exports.arrayEncoding = void 0;
const objects_1 = require("./objects");
Object.defineProperty(exports, "arrayEncoding", { enumerable: true, get: function () { return objects_1.arrayEncoding; } });
Object.defineProperty(exports, "nullPlaceholder", { enumerable: true, get: function () { return objects_1.nullPlaceholder; } });
Object.defineProperty(exports, "objectEncoding", { enumerable: true, get: function () { return objects_1.objectEncoding; } });
const scalar_1 = require("./scalar");
const binary_1 = require("./binary");
const collections_1 = require("./collections");
const errors_1 = require("./errors");
const store_1 = require("../encode/store");
function getDefaultStore() {
    const store = new store_1.EncodingStore();
    store.add(objects_1.objectEncoding, objects_1.arrayEncoding, objects_1.nullPrototypeEncoding, ...scalar_1.wrapperEncodings, scalar_1.dateEncoding, scalar_1.regexpEncoding, ...binary_1.typedArrayEncodings, binary_1.arrayBufferEncoding, collections_1.mapEncoding, collections_1.setEncoding, ...errors_1.errorEncodings, binary_1.sharedArrayBufferEncoding, ...objects_1.unsupportedEncodings);
    return store;
}
exports.getDefaultStore = getDefaultStore;
//# sourceMappingURL=index.js.map