"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserEncoding = void 0;
const interface_1 = require("../interface");
const objects_1 = require("./objects");
const texts_1 = require("../errors/texts");
const MAX_VERSION = 999;
const MIN_VERSION = 1;
class UserEncoding extends interface_1.PrototypeEncoding {
    constructor(specifier, fixedIndex) {
        var _a, _b, _c;
        super();
        this.fixedIndex = fixedIndex;
        this.name = specifier.name;
        this.version = (_a = specifier.version) !== null && _a !== void 0 ? _a : 1;
        this.encodes = specifier.encodes;
        this.decoder = (_b = specifier.decoder) !== null && _b !== void 0 ? _b : (0, objects_1.getPrototypeDecoder)(this.encodes);
        this.encode = (_c = specifier.encode) !== null && _c !== void 0 ? _c : (0, objects_1.getPrototypeEncoder)(this.encodes);
        const { version, name } = this;
        if (typeof version !== "number") {
            throw (0, texts_1.getErrorByCode)("config/proto/version/bad-type")(this);
        }
        if (typeof version !== "number" || !Number.isSafeInteger(version)) {
            throw (0, texts_1.getErrorByCode)("config/proto/version/not-safe")(this);
        }
        if (version > MAX_VERSION || version < MIN_VERSION) {
            throw (0, texts_1.getErrorByCode)("config/proto/version/bad-range")([MIN_VERSION, MAX_VERSION], this);
        }
        if (name != null && typeof name !== "string") {
            throw (0, texts_1.getErrorByCode)("config/spec/proto/bad-name")(name);
        }
    }
}
exports.UserEncoding = UserEncoding;
//# sourceMappingURL=user-encoding.js.map