import { PrototypeEncoding, PrototypeSpecifier, SymbolSpecifier } from "../interface";
export interface ProtoEncodingKeyInfo {
    type: "prototype";
    name: string;
    version: number;
}
export interface SymbolEncodingKeyInfo {
    type: "symbol";
    name: string;
}
export declare type EncodingKeyInfo = ProtoEncodingKeyInfo | SymbolEncodingKeyInfo;
export declare type PrototypeEncodingCtor<T extends object> = {
    new (): PrototypeEncoding<T>;
};
export declare function isSymbolSpecifier(encoding: PrototypeSpecifier | SymbolSpecifier): encoding is SymbolSpecifier;
export declare function defineProtoEncoding<Type extends object, Class extends PrototypeEncodingCtor<Type>>(cls: Class): PrototypeEncoding<Type>;
export declare function mustParseEncodingKey(key: string): EncodingKeyInfo;
//# sourceMappingURL=utils.d.ts.map